-- Global Variables
combatstarttime = nil;

--Buff table:
-- starttime
-- overlaptotal
-- total
-- tickable
-- ticks
-- 
--]
sr = { };
rip = { };
rake = { };
mangle = { };
swing = { };

-- Holds the buffs to track.
buff = { };
targets = { } ;
player = { };
SRTOTALTIME = 0;
-- When the AddOn loads....
function CatFight_OnLoad(self)
	-- Register the game events neccesary for our functionality
	self:RegisterEvent("PLAYER_REGEN_DISABLED");		-- Entering Combat
	self:RegisterEvent("PLAYER_REGEN_ENABLED");		-- Leaving Combat
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");

	self:RegisterEvent("SPELL_AURA_APPLIED");			-- Buff/Debuff Applied
	self:RegisterEvent("SPELL_AURA_REMOVED");			-- Buff/Debuff Removed
	
	local record = { };
	table.insert(buff, record);
	record.name = GetSpellInfo(33876); -- Mangle- Cat
	record = { };
	table.insert(buff, record);
	record.name = GetSpellInfo(1822); -- Rake
	record = { };
	table.insert(buff, record);
	record.name = GetSpellInfo(1079); -- Rip
	record = { };
	table.insert(buff, record);
	record.name = GetSpellInfo(52610); -- Savage Roar
	--[[
	DEFAULT_CHAT_FRAME:AddMessage(record.name,0.8,0.8,1);
	DEFAULT_CHAT_FRAME:AddMessage(buff[1]["name"],0.8,0.8,1);
	DEFAULT_CHAT_FRAME:AddMessage(buff[2].name,0.8,0.8,1);
	--]]
	for i=1, #buff do
		player[buff[i].name] = { };
	end
	
	targets = { };
	local size = #buff
	for i=1, size do
		player[buff[i].name].total = 0;
		player[buff[i].name].overlap = 0;
		player[buff[i].name].overlapticks = 0;
		buff[i].total = 0;
		buff[i].overlap = 0;
		buff[i].overlapticks = 0;
	end
	
end

-- Based upon our registered events, we want different things to happen when each event occurs.
function CatFight_OnEvent(self, event, ...)
	
	--[[ Event spam to inform myself on what happens ]]--
--[[	local message = ""
	for i=1, 15 do
		local arg = select(i, ...);
		if(arg)then
			message = message .. arg .. ", ";
		else
			message = message .. "nil, ";
		end
	end
	ChatFrame4:AddMessage(event .. message);
	--]]
	
	-- Entering Combat
	if ( event == "PLAYER_REGEN_DISABLED") then
		combatstarttime = GetTime();
		local size = #buff
		for i=1, size do
			if( player[buff[i].name].starttime ~= nil and player[buff[i].name].starttime < combatstarttime) then
				player[buff[i].name].starttime = combatstarttime;	
			end
			for j=1,#targets do
				if(targets[j][buff[i].name].starttime ~= nil and targets[j][buff[i].name].starttime < combatstarttime) then
					targets[j][buff[i].name].starttime = combatstarttime;
				end
			end
			player[buff[i].name].total = 0;
			player[buff[i].name].overlap = 0;
			player[buff[i].name].overlapticks = 0;
			buff[i].total = 0;
			buff[i].overlap = 0;
			buff[i].overlapticks = 0;
		end
		--DEFAULT_CHAT_FRAME:AddMessage("Entering combat.",0.8,0.8,1);
		return;
	end
	if ( event == "PLAYER_REGEN_ENABLED") then
		if(combatstarttime == nil) then
			DEFAULT_CHAT_FRAME:AddMessage("Error: No start time available.",0.8,0.8,1);
			return;
		end;
		local endtime = GetTime();
		
		local size = #buff;
		-- Calculations for each buff
		for i=1, size do
			-- Sum up all the total uptimes from each target.
			DEFAULT_CHAT_FRAME:AddMessage("buff["..i.."].total = " .. buff[i].total,0.8,0.8,1);
			local numTargets = #targets;
			for j=1, numTargets do
				
				if(targets[j][buff[i].name].starttime ~= nil) then
					buff[i].total = buff[i].total + endtime - targets[j][buff[i].name].starttime;
				end
				buff[i].total = buff[i].total + targets[j][buff[i].name].total;
				buff[i].overlap = buff[i].overlap + targets[j][buff[i].name].overlap;
				buff[i].overlapticks = buff[i].overlapticks + targets[j][buff[i].name].overlapticks;
			end
			
			-- Add in uptime from player
			if(player[buff[i].name].starttime ~= nil) then
				buff[i].total = buff[i].total + endtime - player[buff[i].name].starttime;
			end
			buff[i].total = buff[i].total + player[buff[i].name].total;
			buff[i].overlap = buff[i].overlap + player[buff[i].name].overlap;
			buff[i].overlapticks = buff[i].overlapticks + player[buff[i].name].overlapticks;
			
			-- Calculate uptime Ratio
			buff[i].uptimeRatio = round(100*buff[i].total/ (endtime - combatstarttime),2);
			if(buff[i].overlap == 0 or buff[i].overlapticks == 0) then
				buff[i].overlapRatio = 0;
			else
				buff[i].overlapRatio = round(100 * buff[i].overlap / buff[i].overlapticks,2);
			end
			
			end
		
		-- Report statistics
		DEFAULT_CHAT_FRAME:AddMessage("Report:", 0.8, 0.8, 1);
		DEFAULT_CHAT_FRAME:AddMessage("Time Elapsed: " .. round((endtime - combatstarttime), 2) .. " seconds.", 0.8,0.8,1);
		local size = #buff;
		for i=1,size do
			DEFAULT_CHAT_FRAME:AddMessage( "["..buff[i].name .. "] Uptime: " .. buff[i].uptimeRatio .. 
												"%, Average overlap: " .. buff[i].overlapRatio .. "%", 0.8,0.8,1);
		end
		
		-- Clear Data
		targets = { };
		combatstarttime = nil;
			
		return;
	end
	
	-- Parsing Combat Events
	if ( event == "COMBAT_LOG_EVENT_UNFILTERED") then
		local timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = select(1, ...);
		local getTimeStamp = GetTime();
		
		if ( type == "SPELL_AURA_APPLIED") then
			-- Only parse combat events sourcing from the player.
			if(sourceGUID ~= UnitGUID("player")) then
				return;
			end;
			local spellId, spellName, spellSchool, auraType = select(9, ...);
			
			-- If target is not known yet, add it to targets list.
			local index = searchTarget(destGUID);
			
			-- If the spellName is one of the buffs to track, track it.
			local size = #buff;
			for i=1,size do
				if(spellName == buff[i].name) then
					if(destGUID == UnitGUID("player")) then
						player[buff[i].name].starttime = getTimeStamp;
						player[buff[i].name].expiretime = select(7,UnitAura("player",buff[i].name));
						player[buff[i].name].duration = player[buff[i].name].expiretime - getTimeStamp;
					else
						targets[index][buff[i].name].starttime = getTimeStamp;
						if(auraType == "BUFF") then
							targets[index][buff[i].name].expiretime = select(7,UnitBuff("target",buff[i].name));
						else
							targets[index][buff[i].name].expiretime = select(7,UnitDebuff("target",buff[i].name));
						end
						targets[index][buff[i].name].duration = targets[index][buff[i].name].expiretime - getTimeStamp;
					end
					return;
				end
			end
			
			return;
		end
		if ( type == "SPELL_AURA_REMOVED") then
			-- Only parse combat events sourcing from the player.
			if(sourceGUID ~= UnitGUID("player")) then
				return;
			end;
			local spellId, spellName, spellSchool, auraType = select(9, ...);
			
			-- If target is not known yet, add it to targets list.
			local index = searchTarget(destGUID);
			
			-- If the spellName is one of the buffs to track, end it and update timer.
			local size = #buff;
			for i=1,size do
				if(spellName == buff[i].name) then
					if(destGUID == UnitGUID("player")) then
						if(player[buff[i].name].starttime ~= nil) then 
							player[buff[i].name].total = player[buff[i].name].total + (getTimeStamp - player[buff[i].name].starttime);
						end
						player[buff[i].name].starttime = nil;
						player[buff[i].name].expiretime = nil;
					else
						if(targets[index][buff[i].name].starttime ~= nil) then 
							targets[index][buff[i].name].total = targets[index][buff[i].name].total + (getTimeStamp - targets[index][buff[i].name].starttime);
						end
						targets[index][buff[i].name].starttime = nil;
						targets[index][buff[i].name].expiretime = nil;
					end
					return;
				end
			end
		end
		
		if(type == "SPELL_AURA_REFRESH") then
			local spellId, spellName, spellSchool, auraType = select(9, ...);

			-- If target is not known yet, add it to targets list.
			local index = searchTarget(destGUID);

			-- If the spellName is one of the buffs to track, calculate overlap time.
			local size = #buff;
			for i=1,size do
				if(spellName == buff[i].name) then
					if(destGUID == UnitGUID("player")) then
						if(player[buff[i].name].expiretime ~= nil) then
							player[buff[i].name].overlap = player[buff[i].name].overlap + (player[buff[i].name].expiretime - getTimeStamp) / player[buff[i].name].duration;
							player[buff[i].name].overlapticks = player[buff[i].name].overlapticks + 1;
						end
						if(player[buff[i].name].starttime ~= nil) then 
							player[buff[i].name].total = player[buff[i].name].total + (getTimeStamp - player[buff[i].name].starttime);
						end
						player[buff[i].name].starttime = getTimeStamp;
						player[buff[i].name].expiretime = select(7,UnitAura("player",buff[i].name));
					else
						if(targets[index][buff[i].name].expiretime ~= nil) then
							targets[index][buff[i].name].overlap = targets[index][buff[i].name].overlap + (targets[index][buff[i].name].expiretime - getTimeStamp) / targets[index][buff[i].name].duration;
							targets[index][buff[i].name].overlapticks = targets[index][buff[i].name].overlapticks + 1;
						end
						if(targets[index][buff[i].name].starttime ~= nil) then 
							targets[index][buff[i].name].total = targets[index][buff[i].name].total + (getTimeStamp - targets[index][buff[i].name].starttime);
						end
						targets[index][buff[i].name].starttime = getTimeStamp;
						if(auraType == "BUFF") then
							targets[index][buff[i].name].expiretime = select(7,UnitBuff("target",buff[i].name));
						else
							targets[index][buff[i].name].expiretime = select(7,UnitDebuff("target",buff[i].name));
						end
						targets[index][buff[i].name].duration = targets[index][buff[i].name].expiretime - getTimeStamp;
						
						return;
					end
				end
			end
		end
	end
end

function round(num, idp)
  return tonumber(string.format("%." .. (idp or 0) .. "f", num))
end

function searchTarget(destGUID)
	local size = #targets;
	local exists = false;
	local index = 0;
	for i=1,size do
		if(destGUID == targets[i].guid) then
			exists = true;
			index = i;
			break;
			
		end
	end
	if(exists == false and destGUID ~= UnitGUID("player")) then
		local record = { };
		for i=1,#buff do
			record[buff[i].name] = { };
			record[buff[i].name].total = 0;
			record[buff[i].name].overlap = 0;
			record[buff[i].name].overlapticks = 0;
		end
		record.guid = destGUID;
		table.insert(targets, record);
		index = #targets;
	end
	
	return index;
end
